#
#  Copyright (C) 2001, 2002 MIT
#
#  This file is part of dotLRN.
#
#  dotLRN is free software; you can redistribute it and/or modify it under the
#  terms of the GNU General Public License as published by the Free Software
#  Foundation; either version 2 of the License, or (at your option) any later
#  version.
#
#  dotLRN is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
#  details.
#

array set config $cf	

set shaded_p $config(shaded_p)
set community_id $config(community_id)

set package_id [dotlrn_community::get_applet_package_id -community_id $community_id -applet_key "dotlrn_data_aggregator"]
set user_id [ad_conn user_id]

permission::require_permission -party_id [ad_conn user_id] -object_id [ad_conn package_id] -privilege read


template::list::create -name aggregator_list -multirow aggregator_list -key data_id -pass_properties {
} -elements {
    name {
        label ""
        display_template {
	        <a href="aggragator-view?data_id=@aggregator_list.data_id@">
				@aggregator_list.name@
			</a>
        }
    }
}

db_multirow aggregator_list select_aggregators {
       select data_id,
		   package_id,
		   name,
		   description
           from data_aggregators da,
				acs_objects ao
	    where package_id = :package_id
		and	  da.data_id = ao.object_id
		and   ao.package_id = :package_id	
        and 't' = acs_permission__permission_p(data_id, :user_id, 'read')
}
